Package org.apache.coyote.http11.filters

# Class IdentityInputFilter

java.lang.Object
org.apache.coyote.http11.filters.IdentityInputFilter

All Implemented Interfaces:
  `InputFilter`, `InputBuffer`, `ApplicationBufferHandler`

public class IdentityInputFilter extends Object implements InputFilter, ApplicationBufferHandler
Identity input filter.

Author:
  Remy Maucherat

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected InputBuffer`
  `buffer`
  Next buffer in the pipeline.
  `protected long`
  `contentLength`
  Content length.
  `protected static final ByteChunk`
  `ENCODING`
  `protected static final String`
  `ENCODING_NAME`
  `protected long`
  `remaining`
  Remaining bytes.
  `protected ByteBuffer`
  `tempRead`
  ByteBuffer used to read leftover bytes.

  ### Fields inherited from interface org.apache.tomcat.util.net.ApplicationBufferHandler

  `EMPTY, EMPTY_BUFFER`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IdentityInputFilter(int maxSwallowSize)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `available()`
  Amount of bytes still available in a buffer.
  `int`
  `doRead(ByteChunk chunk)`
  Deprecated.
  Unused.
  `int`
  `doRead(ApplicationBufferHandler handler)`
  Read from the input stream into the ByteBuffer provided by the ApplicationBufferHandler.
  `long`
  `end()`
  End the current request.
  `void`
  `expand(int size)`
  `ByteBuffer`
  `getByteBuffer()`
  `ByteChunk`
  `getEncodingName()`
  Return the name of the associated encoding; Here, the value is "identity".
  `boolean`
  `isFinished()`
  Has the request body been read fully?
  `void`
  `recycle()`
  Make the filter ready to process the next request.
  `void`
  `setBuffer(InputBuffer buffer)`
  Set the next buffer in the filter pipeline.
  `void`
  `setByteBuffer(ByteBuffer buffer)`
  `void`
  `setRequest(Request request)`
  Read the content length from the request.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### ENCODING_NAME

    protected static final String ENCODING_NAME
    See Also:
      - Constant Field Values

  - ### ENCODING

    protected static final ByteChunk ENCODING

  - ### contentLength

    protected long contentLength
    Content length.

  - ### remaining

    protected long remaining
    Remaining bytes.

  - ### buffer

    protected InputBuffer buffer
    Next buffer in the pipeline.

  - ### tempRead

    protected ByteBuffer tempRead
    ByteBuffer used to read leftover bytes.

- ## Constructor Details

  - ### IdentityInputFilter

    public IdentityInputFilter(int maxSwallowSize)

- ## Method Details

  - ### doRead

    @Deprecated public int doRead(ByteChunk chunk) throws IOException
    Deprecated.
    Unused. Will be removed in Tomcat 9. Use `doRead(ApplicationBufferHandler)`
    Description copied from interface: `InputBuffer`
    Read from the input stream into the given buffer. IMPORTANT: the current model assumes that the protocol will 'own' the buffer and return a pointer to it in ByteChunk (i.e. the param will have chunk.getBytes()==null before call, and the result after the call).
    Specified by:
      `doRead` in interface `InputBuffer`
    Parameters:
      `chunk` - The buffer to read data into.
    Returns:
      The number of bytes that have been added to the buffer or -1 for end of stream
    Throws:
      `IOException` - If an I/O error occurs reading from the input stream

  - ### doRead

    public int doRead(ApplicationBufferHandler handler) throws IOException
    Description copied from interface: `InputBuffer`
    Read from the input stream into the ByteBuffer provided by the ApplicationBufferHandler. IMPORTANT: the current model assumes that the protocol will 'own' the ByteBuffer and return a pointer to it.
    Specified by:
      `doRead` in interface `InputBuffer`
    Parameters:
      `handler` - ApplicationBufferHandler that provides the buffer to read data into.
    Returns:
      The number of bytes that have been added to the buffer or -1 for end of stream
    Throws:
      `IOException` - If an I/O error occurs reading from the input stream

  - ### setRequest

    public void setRequest(Request request)
    Read the content length from the request.
    Specified by:
      `setRequest` in interface `InputFilter`
    Parameters:
      `request` - The request to be associated with this filter

  - ### end

    public long end() throws IOException
    Description copied from interface: `InputFilter`
    End the current request.
    Specified by:
      `end` in interface `InputFilter`
    Returns:
      0 is the expected return value. A positive value indicates that too many bytes were read. This method is allowed to use buffer.doRead to consume extra bytes. The result of this method can't be negative (if an error happens, an IOException should be thrown instead).
    Throws:
      `IOException` - If an error happens

  - ### available

    public int available()
    Amount of bytes still available in a buffer.
    Specified by:
      `available` in interface `InputBuffer`
    Returns:
      The number of bytes that can be read without blocking

  - ### setBuffer

    public void setBuffer(InputBuffer buffer)
    Set the next buffer in the filter pipeline.
    Specified by:
      `setBuffer` in interface `InputFilter`
    Parameters:
      `buffer` - The next buffer

  - ### recycle

    public void recycle()
    Make the filter ready to process the next request.
    Specified by:
      `recycle` in interface `InputFilter`

  - ### getEncodingName

    public ByteChunk getEncodingName()
    Return the name of the associated encoding; Here, the value is "identity".
    Specified by:
      `getEncodingName` in interface `InputFilter`
    Returns:
      The encoding name as a byte chunk to facilitate comparison with the value read from the HTTP headers which will also be a ByteChunk

  - ### isFinished

    public boolean isFinished()
    Description copied from interface: `InputFilter`
    Has the request body been read fully?
    Specified by:
      `isFinished` in interface `InputFilter`
    Returns:
      `true` if the request body has been fully read, otherwise `false`

  - ### setByteBuffer

    public void setByteBuffer(ByteBuffer buffer)
    Specified by:
      `setByteBuffer` in interface `ApplicationBufferHandler`

  - ### getByteBuffer

    public ByteBuffer getByteBuffer()
    Specified by:
      `getByteBuffer` in interface `ApplicationBufferHandler`

  - ### expand

    public void expand(int size)
    Specified by:
      `expand` in interface `ApplicationBufferHandler`